#!/bin/bash
# startup script version 20200305, blob, opcua, bluetooth, copyPrinters, Touchscreen check, ScreenOff 
  
dhclient -v
xset -dpms
xset s noblank
xset s off


rm -R /var/log/*
rm -R /root/.local/share/Trash
rm -R "/root/.local/share/Allen Coding" 

chmod 777 -R /home/share
chmod 660 /dev/ttyAMA0
chmod +x -R /home/share/scripts 

#check if touchscreen present  
#if dmesg | grep -i 'WaveShare Touchscreen as'; then
#	echo "touchscreen is active"
#else
#	echo "touchscreen is inactive, rebooting"
##	echo 0x0 > /sys/devices/platform/bcm2708_usb/buspower   
#	shutdown -r now
#fi 

rm /home/share/acontrol/bin/*.blob
rm /.xsession-errors
rm /media/backup/atouch.backup.img.md5.current
rm /media/backup/boot.tar.gz.md5.current
       
     if [ -f /media/usb/atouch_lite_image ]; then
	cat /sys/block/mmcblk0/device/cid > /boot/serial.cid
     fi 

     #start printer if available
     rm /home/share/update/debugger

     if [ -f ./bluetooth.sh ]; then
	sh ./bluetooth.sh & 
     fi 

     if [ -f ./opcua.sh ]; then
	sh ./opcua.sh & 
     fi 

     if [ -f ./slic.sh ]; then
	sh ./slic.sh &
	sleep 20s
     fi 

     if [ -f /media/usb/atouch_lite_image ]; then
	     if [ ! -f /home/share/update/recoveryfinished.log ]; then	   
	        vcgencmd display_power 0   
	        killall fbi
	        fbi -a -T 1 -noverbose -a /home/share/splash/recovery.png
        	sleep 1s
		vcgencmd display_power 1
		cp /media/usb/atouchlitefiles/atouch.backup.img /media/backup/atouch.backup.img
	        cp /media/usb/atouchlitefiles/atouch.backup.md5.img /media/backup/atouch.backup.md5.img

		cp /media/usb/atouchlitefiles/boot.tar.gz /media/backup/boot.tar.gz
		cp /media/usb/atouchlitefiles/boot.tar.gz.md5 /media/backup/boot.tar.gz.md5
		
		if [ -f /media/backup/atouch.backup.img ]; then	
						
			md5sum /media/backup/atouch.backup.img > /media/backup/atouch.backup.img.md5.current					
			md5sum /media/backup/boot.tar.gz.md5 > /media/backup/boot.tar.gz.md5.current		

			if cmp -s /media/backup/boot.tar.gz.md5.current /media/backup/boot.tar.gz.md5; then				

				if cmp -s /media/backup/atouch.backup.img.md5.current /media/backup/atouch.backup.img.md5; then 
					tar -xzvf /media/backup/boot.tar.gz
					
               				dd if=/media/backup/atouch.backup.img of=/dev/mmcblk0p2
	    				touch /home/share/update/recoveryfinished.log
	    				sleep 1s

            				reboot 

   				else
   					killall fbi
  					echo "md5 failed!"
				fi 

   			else
   				killall fbi
  				echo "md5 failed!"
			fi 

        	fi   		
	     fi 
     fi  

rm /home/share/update/started.log 

while true
do 

     #check if rescue-usb-drive is inserted
     if [ -f /media/usb/atouch_lite_recovery ]; then 
        vcgencmd display_power 0
        killall fbi
        fbi -a -T 1 -noverbose -a /home/share/splash/recovery.png        
        sleep 1s
        vcgencmd display_power 1
	cd /home/share 
	rm -rf /home/share/* 
	cp -rf /media/usb/atouchlitefiles/* /home/share
	rm /home/share/update/started.log
        chmod +x -R /home/share/scripts
	chmod 777 -R /home/share
	sleep 1 
     fi 

     #if not update is running, start acontrol
     if [ ! -f /home/share/update/started.log ]; then
	rm /home/share/update/srecoveryfinished.log
	cd /home/share/acontrol/bin 	

     	if [ ! -f /home/share/debugger/MonoRemoteDebugger.Server.exe ]; then
     	   
     	   #20190329 copy printers
     	   cp /home/share/acontrol/bin/Config/Printers.xml.bak /home/share/acontrol/bin/Config/Printers.xml
     	        	
   	   mono aControl.exe /wifi=n /linuxport=ttyAMA /bootlogo=acf /touch=y /iview=default /width=1024 /height=600 /showtaskbar=n /xdotool=y /nologo /diagraph /single
                          
           if [[ -z $(ps -C fbi -opid=) ]]; then
    	        vcgencmd display_power 0     
           	killall fbi
           	fbi -a -T 1 -noverbose -a /home/share/splash/splash.png  
           	vcgencmd display_power 1
	   fi
 
        fi
     fi

     rm -R "/root/.local/share/Allen Coding"  
     sleep 5
done
